/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
 * Development of this software was sponsored by the Office of Biological  *
 * and Environmental Research of the U.S. Department of Energy's Office    *
 * of Science.                                                             *
 *                                                                         *
 * Copyright 2011 UChicago Argonne, LLC.                                   *
 *                                                                         *
 * Licensed under the Apache License, Version 2.0 (the "License"); you     *
 * may not use this file except in compliance with the License.  You may   *
 * obtain a copy of the License at                                         * 
 *                                                                         *
 *   http://www.apache.org/licenses/LICENSE-2.0                            *
 *                                                                         *
 * Unless required by applicable law or agreed to in writing, software     *
 * distributed under the License is distributed on an "AS IS" BASIS,       *
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or         *
 * implied.  See the License for the specific language governing           *
 * permissions and limitations under the License.                          *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef PNclMBUtils_h
#define PNclMBUtils_h

#include "ParCALCore.hpp"
extern "C" {
#include "ParCALFuncs.h"
}

moab::ErrorCode PNclMBCreateTag(parncl::MBMesh *mesh, const char *tag_name, size_t tstep, size_t nlevs, void *init_val, moab::DataType dt, moab::EntityType ent_type);

moab::ErrorCode PNclMBDupTag(parncl::MBMesh *mesh, const char *to_tag_name, size_t to_tstep, const char *from_tag_name, size_t from_tstep, size_t nlevs, moab::DataType dt, moab::EntityType ent_type);

size_t PNclMBGetChunkSz(parncl::MBMesh *mesh, moab::EntityType ent_type);

moab::DataType PNclNCMapToMB(const nc_type type);
moab::EntityType ParCALLocToMB(const std::string &str);

// FIXME: This function should be renamed and made a member func of mesh class
std::string ParCALGetUniqStr(parncl::MBMesh *mesh);

parncl::MBMesh *create_mb_mesh(moab::Interface *mb_gcore, std::vector<std::string> &fnames, MPI_Comm mb_comm, moab::ParallelComm *mb_pcomm, const std::string &part_method);

#endif
